#!/usr/bin/env python

import sys, os, cgi

import cgitb ; cgitb.enable()

data_dir = "/home/game/pdata/"
game_filename = data_dir + "perildata.txt"

# import the answer data
sys.path.append(data_dir)
from answers import *

# the answers.py file has the answer data for each round:
# The data has the format:
# answers = [] [ # round 1 data
#	[category_name1, answer1-1, answer1-2, answer1-3, answer1-4, answer1-5]
#	[category_name2, answer2-1, answer2-2, answer2-3, answer2-4, answer2-5]
#       ...
# ] [ #round 2 data ... ]
# final = [description, answer]
#

no_strike = "."

stub_data = {
"round":"1",
"score_a":"0",
"score_b":"0",
"score_c":"0",
"player_a_name":"Player A",
"player_b_name":"Player B",
"player_c_name":"Player C",
"cat_0_done":"000000",
"cat_1_done":"000000",
"cat_2_done":"000000",
"cat_3_done":"000000",
"cat_4_done":"000000",
"cat_5_done":"000000",
"cat_6_done":"000000",
}

######################################################


def read_game_data(game_filename):
	game_lines = open(game_filename, "r").readlines()
	data = stub_data.copy()
	for line in game_lines:
		line = line.strip()
		if line and line[0]!='#':
			(name, value) = line.split('=',1)
			#print "data[%s]=%s<br>" % (name, value)
			data[name] = value
	data["game_filename"] = game_filename
	return data

######################################################

def write_game_data(data):
	game_filename = data["game_filename"]
	fd = open(game_filename, "w")
	klist = data.keys()
	klist.sort()
	for name in klist:
		fd.write("%s=%s\n" % (name, data[name]))
	fd.close()

######################################################

def question_value(data, row):
	row = int(row)
	round = int(data["round"])
	return row * (round * 100)

######################################################


# show the game board
# big_board indicates whether to use large fonts and fill the screen

# here is some size data
bigsize_data = {
	"border":0,
	"debug":0,
	"size":5,
	"tsize":7,
	"strike_width":40,
	# main gameboard offsets
	"w0":30,
	"h0":30,
	# main gameboard cell dimensions
	"w":200,
	#"h":80,
	"h":40,
	"cat_font":5,
	# score table stuff
	"score_offset":200,
	"score_spacing":200,
}

smallsize_data = {
	"border":0,
	"debug":0,
	"size":3,
	"tsize":3,
	# main gameboard offsets
	"w0":1,
	"h0":1,
	# main gameboard cell dimensions
	"w":60,
	"h":60,
	"cat_font":3,
	# score table stuff
	"score_offset":1,
	"score_spacing":40,
}

def show_cell(data, row, col):
	round = int(data["round"])
	width = data["w"]
	done = data["cat_%d_done" % col][row]

	if row==0:
		category = answers[round][col][0]
		cat_font = data["cat_font"]
		print """<td width="%s" align="center"><b><font size="%s">%s</font></b></td>""" % (width, cat_font, category)
	else:
		value = question_value(data, row)
		if done=="1":
			value = ""
			
		print """<td width="%s" align="center"><b><font size="%s">
	<a href="peril.cgi?action=show_answer&row=%d&col=%d">
	%s </b>
</td>""" % (width, "5", row, col, value)

# state machine is:
# round = 3 -> show final category
# round = 4 -> show final answer
# (edit data to add wagers and answers)
# round = 5 -> link to final_form
# round = 6 -> reveal answers
# round = 7 -> show winner

def show_final(data, round):
	if round==3:
		print """<table width="100%%" border=1>
<tr height=600><td width="5%%"></td>
<td valign=middle align=center width="90%%"><font size="9">%s</font></td>
<td width="5%%"></td>
</tr></table>""" % final[0]
	if round==4:
		print """<table width="100%%" border=1>
<tr height=600><td width="5%%"></td>
<td valign=middle align=center width="90%%"><font size="9">%s</font></td>
<td width="5%%"></td>
</tr></table>""" % final[1]
	if round==5:
		print """<table width="100%%" border=1>
<tr height=600><td width="5%%"></td>
<td valign=middle align=center width="90%%"><font size="9">Please enter final wages and answers by clicking on this link:<br>
<a href="peril.cgi?action=final_form">Final Data Entry</a></font></td>
<td width="5%%"></td>
</tr></table>"""
	if round==6:
		show_final_result(data)

	if round==7:
		show_winner(data)

def show_final_result(data):
	# determine which values to reveal
	data_copy = {}
	data_copy.update(data)

	for player in ["a", "b", "c"]:
		for field in ["wager", "answer"]:
			hide_str = "hide_"+field+"_"+ player
			hide_flag = data[hide_str]
			if hide_flag == "1":
				data_copy[field+"_"+player] = "XXXXXXXX"

	print """<table width="100%%" border=1>
<tr height=1><td rowspan=4 width="5%%"></td>
<td width="90%%"><td rowspan=4 width="5%%"></td></tr>
"""

	for player in ["a", "b", "c"]:
		format = """
<tr height=200>
<td>
  <table width="100%%%%"><tr>
    <td width="80%%%%">%%(player_%s_name)s</td>
    <td rowspan=2 align=right>Score: %%(score_%s)s</td>
  </tr><tr>
    <td><a href="peril.cgi?action=reveal&field=answer&player=%s">Answer:</a> %%(answer_%s)s</td>
  </tr><tr>
    <td><a href="peril.cgi?action=reveal&field=wager&player=%s">Wager:</a> %%(wager_%s)s</td>
  </tr><tr>
""" % (player, player, player, player, player, player)
		print format % data_copy

		if data["show_final_correct_form_"+player]=="1":
			print """
    <td>
<a href="peril.cgi?action=final_result&player=%s&result=correct">Correct?</a>
<a href="peril.cgi?action=final_result&player=%s&result=wrong">Wrong?</a>
   </td>""" % (player, player)

		print """	
  </tr></table>
</td></tr>"""

#		print """<FORM method=post action="peril.cgi?action=set_values">
#<INPUT type=hidden name="action" value="set_values">

	print """</tr></table>"""

def show_winner(data):
	print "The winner is:  <someone>"


def show_board(data, big_board):
	round = int(data["round"])

	# get size data for display
	if big_board:
		size_data = bigsize_data
	else:
		size_data = smallsize_data

	data.update(size_data)

	# offset table in browser frame, and establish horizontal spacings
	print """
<table border=%(border)s bgcolor="orange" cellspacing=0 cellpadding=0>
<tr bgcolor="LightBlue">
<td width="%(w0)s" rowspan=8></td>
<td height="%(h0)s" width="%(w)s"></td>
<td width="%(w)s"></td>
<td width="%(w)s"></td>
<td width="%(w)s"></td>
<td width="%(w)s"></td>
<td width="%(w)s"></td>
<td width="%(w0)s" rowspan=8></td>
</tr>""" % data

	# title
	title = "Peril"
	if round==2: title = "Double Peril"
	if round>=3: title = "Final Peril"
	data["title"] = title
	print """
<tr bgcolor="LightBlue">
<td colspan=7 align=center><b><font size="%(tsize)s" color="crimson">
%(title)s</font></font></td>
</tr>""" % data

	# show round and multiplier information
	print "</font></td></tr>" % data


	# use this to debug columns
	if data["debug"]==1:
		print """
<tr bgcolor="LightBlue">
<td align=center>1</td>
<td align=center>2</td>
<td align=center>3</td>
<td align=center>4</td>
<td align=center>5</td>
<td align=center>6</td>
</tr>""" % data
	
	# show main board data
	if round<3:
		# print table for normal round
		for row in range(0,6):
			print """<tr height="%(h)s">""" % data
			for col in range(0,6):
				show_cell(data, row, col)
			print "</tr>"

	if round>=3:
		show_final(data, round)
		print "</table>"
		html_end()
		sys.exit(0)

	# end of main gameboard table
	print "</table>"

	# scores
	print"""
<table border=%(border)s bgcolor="orange" cellspacing=0 cellpadding=0>
<tr bgcolor="LightBlue">
<td width="%(score_offset)s"></td>
<td align=center><font size=%(size)s><b>%(player_a_name)s</b></font>
  <table border=1 bordercolor=black><tr><td align=right bgcolor=white>
	<font size=%(size)s>&nbsp;&nbsp;%(score_a)s&nbsp;&nbsp;</font></td></tr>
  </table>
</td>

<td width="%(score_spacing)s"></td>

<td align=center><font size=%(size)s><b>%(player_b_name)s</b></font>
  <table border=1 bordercolor=black><tr><td align=right bgcolor=white>
	<font size=%(size)s>&nbsp;&nbsp;%(score_b)s&nbsp;&nbsp;</font></td></tr>
  </table>
</td>

<td width="%(score_spacing)s"></td>

<td align=center><font size=%(size)s><b>%(player_c_name)s</b></font>
  <table border=1 bordercolor=black><tr><td align=right bgcolor=white>
	<font size=%(size)s>&nbsp;&nbsp;%(score_c)s&nbsp;&nbsp;</font></td></tr>
  </table>
</td>
</tr>
</table>""" % data

	# clean up data
	for key in size_data.keys():
		del data[key]

	# end of show_board()
def show_super_wager_form(data, row, col):
	color="red"
	# FIXTHIS - show SUPER PERIL 
	# FIXTHIS - show wager form, with red background
	print """<table width="100%%" bgcolor="%s" border=1>
<tr height=600><td colspan=3 valign=middle align=center width=100%%>
<font size="9">SUPER<br>PERIL</font>
</td></tr>
<tr><td colspan=3 align=center>
<FORM method=post action="peril.cgi">
<INPUT type=hidden name="action" value="set_super_wager">
<INPUT type=hidden name="row" value="%s">
<INPUT type=hidden name="col" value="%s">
Wager: <INPUT type=text name="wager">
<input type="Submit" name="submit" value="Submit">
<table border=0>
</td></tr>
""" % (color, row, col)

def show_answer(data, row, col, wager=0):
	round = int(data["round"])
	answer = answers[round][int(col)][int(row)]
	value = question_value(data, row)

	if wager:
		value = wager

	# check for super_peril
	super_flag = 0
	for i in range(len(super_peril)):
		sp_tuple = super_peril[i]
		if sp_tuple[0]==round and sp_tuple[1]-1==int(col) and \
			sp_tuple[2]==int(row):
			super_flag = 1

	color = "LightBlue"
	if super_flag and not wager:
		show_super_wager_form(data, row, col)
		return
	
	if super_flag:
		color = "orange"
		
	print """<table width="100%%" bgcolor="%s" border=1>
<tr height=600><td colspan=3 valign=middle align=center width=100%%><font size="9">%s</font>
</td></tr>
<tr><td colspan=3 align=center>
Value is: %d
</td></tr>
""" % (color, answer, value)

	
	data["row"] = row
	data["col"] = col
	data["value"] = value
	
	print """
<tr height=1><td></td></tr>
<tr>
<td width="5%%">
<a href="peril.cgi?action=a_correct&row=%(row)s&col=%(col)s&value=%(value)s">a</a>
<a href="peril.cgi?action=b_correct&row=%(row)s&col=%(col)s&value=%(value)s">b</a>
<a href="peril.cgi?action=c_correct&row=%(row)s&col=%(col)s&value=%(value)s">c</a>
</td>

<td width="90%%" align=center>
<a href="peril.cgi?action=done&row=%(row)s&col=%(col)s">done</td>

<td width="5%%">
<a href="peril.cgi?action=a_wrong&row=%(row)s&col=%(col)s&value=%(value)s">a</a>
<a href="peril.cgi?action=b_wrong&row=%(row)s&col=%(col)s&value=%(value)s">b</a>
<a href="peril.cgi?action=c_wrong&row=%(row)s&col=%(col)s&value=%(value)s">c</a>
</td>

</tr></table>
""" % data


######################################################

def html_start():
	print """
<HTML>
<TITLE>Peril</TITLE>
<BODY BGCOLOR="LightBlue">
"""

######################################################

def html_end():
	print """
<p><table width="100%%" border=1><tr>
<td align=left><a href="peril.cgi">main</a></td>
<td><a href="peril.cgi?action=next">next round</a></td>
<td><a href="peril.cgi?action=undo">undo</a></td>
<td><a href="peril.cgi?action=show_form">edit game data</a></td>
<td><a href="peril.cgi?action=reset">reset</a></td>
</tr></table>
</BODY>
</HTML>"""

######################################################

def right_answer(data, form, player):
	round = int(data["round"])
	# add question value to player's score
	score_str = "score_"+player
	score = int(data[score_str])
	row = int(form["row"].value)
	col = int(form["col"].value)
	value = int(form["value"].value)
	score += value
	data[score_str] = str(score)

	# mark question as answered
	index = "cat_%d_done" % col
	done = data[index]
	done = done[:row]+"1"+done[row+1:]
	data[index] = done
	write_game_data(data)

def wrong_answer(data, form, player):
	round = int(data["round"])
	# subtract question value from player's score
	score_str = "score_"+player
	score = int(data[score_str])
	row = form["row"].value
	col = form["col"].value
	#value = question_value(data, row)
	value = int(form["value"].value)
	score -= value
	data[score_str] = str(score)

	write_game_data(data)

	show_answer(data, row, col)
	html_end()
	sys.exit(0)

def done(data, form):
	row = int(form["row"].value)
	col = int(form["col"].value)

	# mark question as answered
	index = "cat_%d_done" % col
	done = data[index]
	done = done[:row]+"1"+done[row+1:]
	data[index] = done
	write_game_data(data)


######################################################

def do_action(action, data, form):
	round = int(data["round"])
	print "action=<b>%s</b><br>" % action
	if action=="none":
		return
	if action=="show_answer":
		row = form["row"].value
		col = form["col"].value
		show_answer(data, row, col)
		html_end()
		sys.exit(0)
	if action=="a_correct":
		right_answer(data, form, "a")
		return
	if action=="b_correct":
		right_answer(data, form, "b")
		return
	if action=="c_correct":
		right_answer(data, form, "c")
		return
	if action=="a_wrong": wrong_answer(data, form, "a")
	if action=="b_wrong": wrong_answer(data, form, "b")
	if action=="c_wrong": wrong_answer(data, form, "c")
	if action=="done":
		done(data, form)
		return

	if action=="set_super_wager":
		row = form["row"].value
		col = form["col"].value
		wager = int(form["wager"].value)
		show_answer(data, row, col, wager)
		html_end()
		sys.exit(0)

	if action=="reset":
		print """<h1>### RESET ###</h1>
Are you sure you want to reset the game?<br>
If so, click on the link below to really reset the game:<br>
<a href="peril.cgi?action=really_reset">Really Reset!!</a>
"""
		return

	if action=="really_reset":
		data["score_a"]="0"
		data["score_b"]="0"
		data["score_c"]="0"
		data["round"]="1"
		round = 1

		# reset the "done" flags
		for i in range(0,6):
			data["cat_%d_done" % i] = "000000"

		write_game_data(data)
		return

	if action=="next":
		round += 1
		data["round"] = str(round)

		# reset the "done" flags
		for i in range(0,6):
			data["cat_%d_done" % i] = "000000"

		write_game_data(data)
		return

	if action=="show_form":
		# show a form to set values directly
		# bank, score_a, score_b, round, strike_1,2,3
		print "Please edit the game data:"
		print """<FORM method=post action="peril.cgi?action=set_values">
<INPUT type=hidden name="action" value="set_values">
<table border=0>
"""
		keys = data.keys()
		keys.sort()
		for name in keys:
			value = data[name]
			print """
<tr>
<TD BGCOLOR="#dddddd" WIDTH="55%%">
%s</td>
<TD WIDTH="33%%"><INPUT type="Text" name="%s" size="50" value="%s">
</TD>
</tr>""" % (name, name, value)

		print """
</table>
<ul>
<input type="Submit" name="submit" value="Submit">
</ul>"""
		return

	if action=="set_values":
		# set values from the form
		for name in data.keys():
			value = form[name].value
			data[name] = value
		print "Set values for game from form data!!"
		write_game_data(data)
		return

	if action=="final_form":
		print "Please enter final round game data:"
		print """<FORM method=post action="peril.cgi?action=set_final_values">
<INPUT type=hidden name="action" value="set_final_values">
<table border=0>
"""
		for player in ["a", "b", "c"]:
			for field in ["wager", "answer"]:
				print """
<tr>
<TD BGCOLOR="#dddddd" WIDTH="55%%">
%s_%s</td>
<TD WIDTH="33%%"><INPUT type="Text" name="%s_%s" size="50">
<INPUT type=hidden name="hide_%s_%s" value="1">
</TD>
</tr>""" % (field, player, field, player, field, player)
			

		print """
</table>
<ul>
<input type="Submit" name="submit" value="Submit">
</ul>"""
		return

	if action=="set_final_values":
		# set values from the form
		for player in ["a", "b", "c"]:
			for field in ["wager", "answer"]:
				name = field+"_"+player
				value = form[name].value
				data[name] = value
				name = "hide_"+field+"_"+player
				value = form[name].value
				data[name] = value
			data["show_final_correct_form_"+player] = "0"
		# increment round
		round += 1
		data["round"] = str(round)

		print "Set final values for game from form data!!"
		write_game_data(data)
		return

	if action=="reveal":
		field = form["field"].value
		player = form["player"].value
		data["hide_"+field+"_"+player] = "0"
		if field=="wager":
			data["show_final_correct_form_"+player] = "1"
		write_game_data(data)
		return

	if action=="final_result":
		player = form["player"].value
		result = form["result"].value
		wager = int(data["wager_"+player])
		score = int(data["score_"+player])
		if result=="correct":
			score += wager
		else:
			score -= wager
			if score < 0:
				score = 0
		data["score_"+player] = str(score)
		data["show_final_correct_form_"+player] = "0"
		write_game_data(data)
		return


	print "-- Error: unknown action %s --" % action

	# end of do_action()

######################################################

if __name__ == "__main__":
	print "Content-type: text/html"
	print ""
	form = cgi.FieldStorage()

	html_start()
	data = read_game_data(game_filename)

	if "action" in form:
		action = form["action"].value
		do_action(action, data, form)
		
		# do_action doesn't return if it handled the action completely

	show_board(data, 1)
	html_end()
