#!/usr/bin/env python

import sys, os, cgi

survey_file = "/home/survey/data/survey.txt"

def show_survey(filename):
	print """
<HTML>
<TITLE>CELF Embedded Linux Survey</TITLE>
<BODY>
<H1 align=center>CELF Embedded Linux Survey</H1>
"""
	
	try:
		survey_lines = open(survey_file, "ro").readlines()
	except:
		print """
			<h2 align=center>Survey Questions Error</h2>
			<p>
			<font color="red">Error: can't open survey file</font>"""
		sys.exit(1)

	print """
<h2>Survey Instructions:</h2>
For each question or statement, please enter the first
thing that comes to your mind.  Don't double-think it, or research an
answer. 
<p>
There are no "right" or "wrong" answers, and you will not
be graded!
<p>
Just respond with whatever comes to mind.
<p>
<h2>Survey Questions:</h2>
<p>

<FORM method=post action="/survey-cgi/survey.cgi">
<INPUT type=hidden name="state" value="save">
<table border=0>
"""
	q_num = 1 
	#print survey_lines
	for line in survey_lines:
		print """
<tr>
<TD BGCOLOR="#dddddd" WIDTH="55%%">
%s</TD>
<TD WIDTH="33%%"><INPUT type="Text" name="answer%d" size="50" value="">
</TD>
</tr>""" % (line, q_num)
		q_num += 1

	print """
</TABLE>

<ul><ul>
Thanks for taking the survey.
<INPUT type="Submit" name="submit" value="Submit">
</ul></ul>
</FORM>
</BODY>
</HTML>"""
	sys.exit(0)

def save_survey(survey_file, form):
	print """
<HTML>
<TITLE>Survey Results</title>
<h1 align=center>Survey Results</h1>
"""
	try:
		survey_lines = open(survey_file, "ro").readlines()
	except:
		print """
			<h2 align=center>Survey Questions Error</h2>
			<p>
			<font color="red">Error: can't open survey file</font>"""
		sys.exit(1)

	# print out the survey results
	print "Here are your survey results:<p>"
	missing = 0
	for q_num in range(len(survey_lines)):
		field = "answer%d" % (q_num + 1)
		print survey_lines[q_num]
		if field in form:
			print "<b>"
			print form[field].value
			print "</b>"
		else:
			missing += 1
			print "<font color=red>[missing answer]</font>"
		print "<br>"

	if missing:
		print """Please answer all the questions!
<p>Please press your browser's "BACK" button, and go back to answer the
questions with missing answers."""
		sys.exit(1)

	print "<p>"

	if "submit" not in form:
		print 'missing "submit" in form???'
		sys.exit(1)

	client_addr = os.getenv("REMOTE_ADDR", "unknown")

	# if file exists, just append this answer at end
	# if file doesn't exist, create it with question at top
	survey_dir = os.path.dirname(survey_file)
	problem = 0
	for q_num in range(len(survey_lines)):
		field = "answer%d" % (q_num + 1)
		line = survey_lines[q_num]
		qa_filename = survey_dir+os.sep+("q-and-a-%d.txt" % (q_num + 1))
		# create file if not present
		if not os.path.isfile(qa_filename):
			print "Creating file %s<br>" % qa_filename
			qa_file = open(qa_filename, "w")
			qa_file.write(line)
			qa_file.write("----------------------------------\n")
			qa_file.close()

		try:
			qa_file = open(qa_filename, "a")
			qa_file.write("%15s: " % client_addr)
			qa_file.write(form[field].value+"\n")
			qa_file.close()
			print ".",
		except:
			problem = 1
			print "<font color=red>Problem writing to file %s</font>" % qa_filename

	if problem:
		print """
<h1 align=center>Survey Results NOT Saved</h1>
The survey results were NOT saved successfully.
Please report this problem to tim(dot)bird(at)am(dot)sony(dot)com.
<p>"""
	else:
		print """
<h1 align=center>Survey Results Saved</h1>
The survey results were saved successfully.
<p>
Thank you participating in the survey.
"""
	sys.exit(0)

if __name__ == "__main__":
	print "Content-type: text/html"
	print ""
	form = cgi.FieldStorage()

	if "state" not in form:
		show_survey(survey_file)
	state = form["state"].value
	if state=="save":
		save_survey(survey_file, form)
	if state=="play":
		print "Play not supported yet"
		
